/*
 *  Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */

#pragma once

#include "p44vdc_common.hpp"
#include "vdchost.hpp"


const char* ADDONVDC_VENDOR_NAME = "plan44.ch";
const char* ADDONVDC_DESCRIPTION_TEMPLATE = "%M @ %S";
const char* ADDONVDC_VDCMODELNAME_TEMPLATE = "dS %m";


namespace p44 {

/// specific vdc host class for predefining vendor, model etc.
class AddonVdcHost : public VdcHost
{
    typedef VdcHost inherited;

  public:
    AddonVdcHost()
  {
      setProductName(PACKAGE_NAME);
      setProductVersion(PACKAGE_VERSION);
      setDescriptionTemplate(ADDONVDC_DESCRIPTION_TEMPLATE);
      setVdcModelNameTemplate(ADDONVDC_VDCMODELNAME_TEMPLATE);
  }

    virtual string vendorName() P44_OVERRIDE { return ADDONVDC_VENDOR_NAME; };
};
typedef boost::intrusive_ptr<AddonVdcHost> AddonVdcHostPtr;

} // namespace p44
