/*
 *  Copyright (c) 2020 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */
#pragma once


#include "client.hpp"
#include "httpcomm.hpp"

namespace vdcutils {

  class IHttpClient
  {
    public:
    virtual ~IHttpClient() = default;
    virtual bool getRequest(const std::string& aUrl, p44::HttpCommCB aResponseCB) = 0;
  };

  class HttpClient : public IHttpClient
  {
    Client<p44::HttpComm> mClientImpl;

    public:
    HttpClient()
    {
      mClientImpl.isMemberVariable();
    }

    virtual bool getRequest(const std::string& aUrl, p44::HttpCommCB aResponseCB) override
    {
      return mClientImpl.getApi().httpRequest(aUrl.c_str(), aResponseCB);
    }
  };

} // namespace vdcutils


