/*
 *  Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */
#pragma once

#if __cplusplus >= 201402L

#include "weboperation.hpp"
#include "httpclient.hpp"

namespace vdcutils {

  template <>
  struct CallbackType<HttpClient> { using type = p44::HttpCommCB; };

  template <>
  struct DataType<HttpClient> { using type = string; };

  template <>
  inline void WebOperation<HttpClient>::processAnswer(const string& aResponse, p44::ErrorPtr aError)
  {
    LOG(LOG_DEBUG, "- Processing Http response:\n- Error(%s)\n- Response: '%s'",
                    aError ? aError->description().c_str() : "ok", aResponse.c_str());

    httpClient.updateAccountStatus(aError);
    if (!isAuthPending(aError)) {
      response += aResponse;
      error = aError;
      /* In streaming mode data chunks are error free.
       * When request is complete, there is additional
       * response with empty data and error.*/
      completed = (aResponse.empty() || !streamingReq);

    }
  }

  using HttpOperation = WebOperation<HttpClient>;


} // namespace vdcutils

#endif

