/*
 *  Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */
#pragma once

#if __cplusplus >= 201402L
#include "boost/signals2.hpp"
#include <functional>

namespace vdcutils {

template <typename Signature>
class IConnectable
{
  public:

    using SignatureType = Signature;
    using CallbackType = std::function<Signature>;

    virtual ~IConnectable() {}
    virtual boost::signals2::scoped_connection registerCallback(const CallbackType& aCallback) = 0;
};

} // namespace vdcutils

#endif

