/*
 *  Copyright (c) 2020 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */
#pragma once

#include "p44utils/jsonobject.hpp"
#include "vdc-utils/exception.hpp"


namespace vdcutils::json {


  /* JsonSerializable */


  class SerializationException : public vdcutils::Exception
  {
    using vdcutils::Exception::Exception;
  };

  class IJsonSerializable
  {
    public:
    virtual ~IJsonSerializable() = default;
    virtual p44::JsonObjectPtr toJson() const = 0;
    virtual void fromJson(p44::JsonObjectPtr aJson) = 0;
  };

}// namespace vdcutils::json


