/*
 *  Copyright (c) 2020 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */
#pragma once

#include <optional>
#include <string>
#include "p44utils/jsonobject.hpp"
#include "vdc-utils/exception.hpp"


namespace vdcutils::json {

  class JsonHelperException : public Exception
  {
  public:
    using vdcutils::Exception::Exception;
  };

  p44::JsonObjectPtr get(p44::JsonObjectPtr aJson, const std::string& aName);
  p44::JsonObjectPtr get(p44::JsonObject& aJson, const std::string& aName);
  std::vector<std::string> getStringArray(p44::JsonObjectPtr aArrayJson);
  std::vector<std::string> getStringArray(p44::JsonObject& aArrayJson);
  std::vector<std::string> getStringArray(p44::JsonObjectPtr aJson, const std::string& aName);
  std::vector<std::string> getStringArray(p44::JsonObject& aJson, const std::string& aName);


  std::optional<std::string> getJsonStringValue(p44::JsonObjectPtr aRootJson, const std::string& aKey);
  std::optional<int> getJsonInt32Value(p44::JsonObjectPtr aRootJson, const std::string& aKey);
  std::optional<double> getJsonDoubleValue(p44::JsonObjectPtr aRootJson, const std::string& aKey);
  std::optional<bool> getJsonBoolValue(p44::JsonObjectPtr aRootJson, const std::string& aKey);

  p44::JsonObjectPtr newJsonItem(bool aValue);
  p44::JsonObjectPtr newJsonItem(const std::string& aValue);

}// namespace p44


