/*
 *  Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */
#pragma once

#if __cplusplus >= 201402L

#include "weboperation.hpp"
#include "jsonclient.hpp"

namespace vdcutils {

  template <>
  struct CallbackType<JsonClient> { using type = p44::JsonWebClientCB; };

  template <>
  struct DataType<JsonClient> { using type = p44::JsonObjectPtr; };

  template <>
  inline void WebOperation<JsonClient>::processAnswer(const p44::JsonObjectPtr& aResponse, p44::ErrorPtr aError)
  {
    LOG(LOG_DEBUG, "- Processing Json response:\n- Error(%s)\n- Response: '%s'",
                    aError ? aError->description().c_str() : "ok",
                        aResponse ? aResponse->json_c_str() : "<no json data>");

    httpClient.updateAccountStatus(aError);
    if (!isAuthPending(aError)) {
      // save response data
      error = aError;
      response = aResponse;
      // done
      completed = true;
    }
  }

  using JsonOperation = WebOperation<JsonClient>;


} // namespace vdcutils

#endif

