AC_DEFUN([AX_SANITIZER_OPTS], [
  SANITIZER_LIBS=
  SANITIZER_CPPFLAGS=

  AC_ARG_ENABLE([sanitizer],
    AS_HELP_STRING([--enable-sanitizer], [Enable address sanitizer]))

  AS_IF([test "x$enable_sanitizer" = "xyes"], [
    AC_CHECK_LIB(asan, __asan_report_load4, [
      SANITIZER_LIBS="-lasan"
      SANITIZER_CPPFLAGS="-fsanitize=address"
    ], [
    AC_MSG_ERROR([You specified --enable-sanitizer, but libasan was not found on your system!])
    ])
  ])

    AC_SUBST(SANITIZER_CPPFLAGS)
    AC_SUBST(SANITIZER_LIBS)
])

AC_DEFUN([AX_DEBUG_OPTS], [
  AC_ARG_ENABLE([debug],
  [  --enable-debug    Turn on debugging],
  [case "${enableval}" in
    yes) debug=true ;;
    no)  debug=false ;;
    *) AC_MSG_ERROR([bad value ${enableval} for --enable-debug]) ;;
  esac],[debug=false])
  AM_CONDITIONAL([DEBUG], [test x$debug = xtrue])
])
