/*
 *  Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */

#pragma once

#include <cstddef>
#include <array>
#include <optional>


namespace vdcutils {

using MacAddressBytes = std::array<std::byte, 6>;

class MacAddress {

  MacAddressBytes mMacAddress;

  explicit MacAddress(const MacAddressBytes& aBinaryMac);

  public:
  MacAddress()=default;
  static MacAddress fromInteger(uint64_t aMacInteger);
  static std::optional<MacAddress> fromIp(const std::string& aIpString);
  static std::optional<MacAddress> fromString(std::string aMacString);

  std::string toString() const;
  const MacAddressBytes& toBytes() const { return mMacAddress; }
};

bool operator==(const MacAddress& aMacAddressL, const MacAddress& aMacAddressR);

} // namespace vdcutils
