/*
 *  Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */
#pragma once

#if __cplusplus >= 201402L

#include "boost/intrusive_ptr.hpp"

namespace vdcutils {

template<typename T, typename... Args>
auto make_intrusive(Args&&... args)
{
    return boost::intrusive_ptr<T>(new T(std::forward<Args>(args)...));
}

} // namespace vdcutils

#endif

