/*
 *  Copyright (c) 2019 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */

#include "jsonobject.hpp"
#include <boost/circular_buffer.hpp>
#include <ctime>


namespace vdcutils {


enum class MessageLevel
{
  Success,
  Info,
  Warning,
  Error
};


class MessageBox
{
  struct Message
  {
    std::time_t timestamp;
    MessageLevel level;
    p44::JsonObjectPtr message;

    p44::JsonObjectPtr toJson();
  };

  using Messages_t = boost::circular_buffer<Message>;
  Messages_t mMessages;

  public:
  explicit MessageBox(size_t aSize);

  void addMessage(MessageLevel aLevel, p44::JsonObjectPtr aMessage);

  p44::JsonObjectPtr toJson();
};



} // namespace vdcutils
