/*
 *  Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */

#pragma once

#include "gmock/gmock.h"
#include "vdc-utils/persistentstorage/ipersistentstoragefactory.hpp"



namespace vdcunittest {

class PersistentStorageFactoryMock : public vdcutils::IPersistentStorageFactory
{
public:
  MOCK_METHOD1(addRecord, void(const vdcutils::PersistentRecordRef<std::string>& aRecord));
  MOCK_METHOD1(addRecord, void(const vdcutils::PersistentRecordCB<std::string>& aRecord));
  MOCK_METHOD1(addRecord, void(const vdcutils::PersistentRecordRef<bool>& aRecord));
  MOCK_METHOD1(addRecord, void(const vdcutils::PersistentRecordCB<bool>& aRecord));
  MOCK_METHOD1(addRecord, void(const vdcutils::PersistentRecordRef<vdcutils::StringList>& aRecord));
  MOCK_METHOD1(addRecord, void(const vdcutils::PersistentRecordCB<vdcutils::StringList>& aRecord));

  virtual std::unique_ptr<vdcutils::IPersistentStorageWithRowId> createStorageWithRowId(const std::string& aRowId, const std::string& aTableName) override
  {
    return std::unique_ptr<vdcutils::IPersistentStorageWithRowId>(createStorageWithRowIdProxy(aRowId, aTableName));
  }

  MOCK_METHOD2(createStorageWithRowIdProxy, vdcutils::IPersistentStorageWithRowId*(const std::string& aRowId, const std::string& aTableName));
};

} // namespace vdcunittest



