/*
 *  Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */

#pragma once

#include "gmock/gmock.h"
#include "vdc.hpp"

namespace vdcunittest {

class VdcMock : public p44::Vdc
{
public:
  VdcMock(int aInstanceNumber, p44::VdcHost *aVdcHostP, int aTag) : Vdc(aInstanceNumber, aVdcHostP, aTag) {}

  MOCK_METHOD2(scanForDevices, void(p44::StatusCB, p44::RescanMode));
  MOCK_CONST_METHOD0(vdcClassIdentifier, const char*());
  MOCK_CONST_METHOD0(vdcModelSuffix, string());
};

} // namespace vdcunittest

