/*
 *  Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */

#pragma once
#include "p44utils/socketcomm.hpp"

namespace vdcutils {

using UdpRawDataHandler = boost::function<void(std::vector<uint8_t>&, p44::ErrorPtr)>;

class UdpServer : public p44::SocketComm {

    using inherited = p44::SocketComm;

    std::string host;
    std::string port;
    UdpRawDataHandler rawDataHandler;

  public:
    UdpServer(p44::MainLoop& aMainLoop, const std::string& aHost, const std::string& aPort);
    virtual ~UdpServer();

    void setPort(const std::string& aPort) { port = aPort; }
    void setUdpRawDataHandler(UdpRawDataHandler aDataHandler) { rawDataHandler = aDataHandler; }
    p44::ErrorPtr startServer();

  private:
    void readData(p44::ErrorPtr aError);

};
using UdpServerPtr = boost::intrusive_ptr<UdpServer>;


} // namespace vdcutils
