/*
 *  Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */

// File scope debugging options
// - Set ALWAYS_DEBUG to 1 to enable DBGLOG output even in non-DEBUG builds of this file
#define ALWAYS_DEBUG 0
// - set FOCUSLOGLEVEL to non-zero log level (usually, 5,6, or 7==LOG_DEBUG) to get focus (extensive logging) for this file
//   Note: must be before including "logger.hpp" (or anything that includes "logger.hpp")
#define FOCUSLOGLEVEL 7

#include "weboperation.hpp"

#if __cplusplus >= 201402L

const char* vdcutils::toCStr(HttpMethod aMethod)
{
  switch(aMethod) {
  case HttpMethod::GET : return "GET";
  case HttpMethod::PUT : return "PUT";
  case HttpMethod::POST : return "POST";
  }
  return nullptr;
}


#endif

