/*
 *  Copyright (c) 2019 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */

#pragma once

#include <string_view>
#include <functional>
#include <future>
#include <thread>
#include <boost/asio/io_service.hpp>

#include "vdc-utils/websocket/error.hpp"
#include "vdc-utils/loggerext.hpp"
#include "p44utils/mainloop.hpp"

#define LOG_IOS(lvl, ...) LOG_M(lvl, "IO Service", ##__VA_ARGS__)


namespace vdcutils::websocket {


/* ===== Async IOService ===== */


struct IOServiceHanlder
{
  boost::asio::io_service mIOService;
  std::shared_ptr<boost::asio::io_service::work> mWork;

  IOServiceHanlder();
  ~IOServiceHanlder();

  void runRoutine();
  void stop();

  template <class Handler>
  void async(Handler aHandler) {
    mIOService.post(aHandler);
  }
};


} // namespace vdcutils
