/*
 *  Copyright (c) 2019 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of vdc-utils
 */

#pragma once

#include "vdc-utils/websocket/client.hpp"
#include "p44utils/operationqueue.hpp"
#include "p44utils/jsonobject.hpp"
#include "p44utils/mainloop.hpp"


#define LOG_WOP(lvl, ...) LOG_M(lvl, "WebSocket Operation", ##__VA_ARGS__)


namespace vdcutils::websocket {


/* ===== Websocket operation ===== */


class Operation : public p44::Operation
{
  IOperationClient& mClient;

  uint mRetryLimit{3};
  bool mCompleted{false};
  const std::string mData;
  p44::StatusCB mResultHandler;
  p44::ErrorPtr mError;

  public:
  Operation(IOperationClient& aClient, const std::string& aJsonData, p44::StatusCB aResultHandler);

  virtual bool initiate() override;
  virtual bool hasCompleted() override;
  virtual p44::OperationPtr finalize() override;
  virtual void abortOperation(p44::ErrorPtr aError) override;

  void restartOperation();
  virtual void sendRequest();
};

} // namespace vdcutils
